## llvm-toolchain-3.7 3.7~+rc4

=== clang-tidy/CMakeLists.txt ===
set(LLVM_LINK_COMPONENTS
  Support
  )

add_clang_library(clangTidy
  ClangTidy.cpp
  ClangTidyModule.cpp
  ClangTidyDiagnosticConsumer.cpp
  ClangTidyOptions.cpp

  DEPENDS
  ClangSACheckers

  LINK_LIBS
  clangAST
  clangASTMatchers
  clangBasic
  clangFrontend
  clangRewrite
  clangSema
  clangStaticAnalyzerCore
  clangStaticAnalyzerFrontend
  clangTooling
  clangToolingCore
  )

add_subdirectory(tool)
add_subdirectory(llvm)
add_subdirectory(google)
add_subdirectory(misc)
add_subdirectory(readability)
add_subdirectory(utils)

=== docs/CMakeLists.txt ===

if (DOXYGEN_FOUND)
if (LLVM_ENABLE_DOXYGEN)
  set(abs_srcdir ${CMAKE_CURRENT_SOURCE_DIR})
  set(abs_builddir ${CMAKE_CURRENT_BINARY_DIR})

  if (HAVE_DOT)
    set(DOT ${LLVM_PATH_DOT})
  endif()

  if (LLVM_DOXYGEN_EXTERNAL_SEARCH)
    set(enable_searchengine "YES")
    set(searchengine_url "${LLVM_DOXYGEN_SEARCHENGINE_URL}")
    set(enable_server_based_search "YES")
    set(enable_external_search "YES")
    set(extra_search_mappings "${LLVM_DOXYGEN_SEARCH_MAPPINGS}")
  else()
    set(enable_searchengine "NO")
    set(searchengine_url "")
    set(enable_server_based_search "NO")
    set(enable_external_search "NO")
    set(extra_search_mappings "")
  endif()

  # If asked, configure doxygen for the creation of a Qt Compressed Help file.
  if (LLVM_ENABLE_DOXYGEN_QT_HELP)
    set(CLANG_DOXYGEN_QCH_FILENAME "org.llvm.clang.qch" CACHE STRING
      "Filename of the Qt Compressed help file")
    set(CLANG_DOXYGEN_QHP_NAMESPACE "org.llvm.clang" CACHE STRING
      "Namespace under which the intermediate Qt Help Project file lives")
    set(CLANG_DOXYGEN_QHP_CUST_FILTER_NAME "Clang ${CLANG_VERSION}" CACHE STRING
      "See http://qt-project.org/doc/qt-4.8/qthelpproject.html#custom-filters")
    set(CLANG_DOXYGEN_QHP_CUST_FILTER_ATTRS "Clang,${CLANG_VERSION}" CACHE STRING
      "See http://qt-project.org/doc/qt-4.8/qthelpproject.html#filter-attributes")
    set(clang_doxygen_generate_qhp "YES")
    set(clang_doxygen_qch_filename "${CLANG_DOXYGEN_QCH_FILENAME}")
    set(clang_doxygen_qhp_namespace "${CLANG_DOXYGEN_QHP_NAMESPACE}")
    set(clang_doxygen_qhelpgenerator_path "${LLVM_DOXYGEN_QHELPGENERATOR_PATH}")
    set(clang_doxygen_qhp_cust_filter_name "${CLANG_DOXYGEN_QHP_CUST_FILTER_NAME}")
    set(clang_doxygen_qhp_cust_filter_attrs "${CLANG_DOXYGEN_QHP_CUST_FILTER_ATTRS}")
  else()
    set(clang_doxygen_generate_qhp "NO")
    set(clang_doxygen_qch_filename "")
    set(clang_doxygen_qhp_namespace "")
    set(clang_doxygen_qhelpgenerator_path "")
    set(clang_doxygen_qhp_cust_filter_name "")
    set(clang_doxygen_qhp_cust_filter_attrs "")
  endif()

  option(LLVM_DOXYGEN_SVG
    "Use svg instead of png files for doxygen graphs." OFF)
  if (LLVM_DOXYGEN_SVG)
    set(DOT_IMAGE_FORMAT "svg")
  else()
    set(DOT_IMAGE_FORMAT "png")
  endif()

  configure_file(${CMAKE_CURRENT_SOURCE_DIR}/doxygen.cfg.in
    ${CMAKE_CURRENT_BINARY_DIR}/doxygen.cfg @ONLY)

  set(abs_top_srcdir)
  set(abs_top_builddir)
  set(DOT)
  set(enable_searchengine)
  set(searchengine_url)
  set(enable_server_based_search)
  set(enable_external_search)
  set(extra_search_mappings)
  set(clang_doxygen_generate_qhp)
  set(clang_doxygen_qch_filename)
  set(clang_doxygen_qhp_namespace)
  set(clang_doxygen_qhelpgenerator_path)
  set(clang_doxygen_qhp_cust_filter_name)
  set(clang_doxygen_qhp_cust_filter_attrs)
  set(DOT_IMAGE_FORMAT)

  add_custom_target(doxygen-clang
    COMMAND ${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/doxygen.cfg
    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
    COMMENT "Generating clang doxygen documentation." VERBATIM)

  if (LLVM_BUILD_DOCS)
    add_dependencies(doxygen doxygen-clang)
  endif()

  if (NOT LLVM_INSTALL_TOOLCHAIN_ONLY)
    install(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/doxygen/html
      DESTINATION docs/html)
  endif()
endif()
endif()

if (LLVM_ENABLE_SPHINX)
  if (SPHINX_FOUND)
    include(AddSphinxTarget)
    if (${SPHINX_OUTPUT_HTML})
      add_sphinx_target(html clang)
    endif()
    if (${SPHINX_OUTPUT_MAN})
      add_sphinx_target(man clang)
    endif()
  endif()
endif()

=== tool-template/Makefile ===
##===-------- tools/toolTemplate/Makefile ------------------*- Makefile -*-===##
#
#                     The LLVM Compiler Infrastructure
#
# This file is distributed under the University of Illinois Open Source
# License. See LICENSE.TXT for details.
#
##===----------------------------------------------------------------------===##

CLANG_LEVEL := ../../..

TOOLNAME = tool-template
NO_INSTALL = 1

# No plugins, optimize startup time.
TOOL_NO_EXPORTS = 1

include $(CLANG_LEVEL)/../../Makefile.config
LINK_COMPONENTS := $(TARGETS_TO_BUILD) asmparser bitreader support mc option
USEDLIBS = clangTooling.a clangFrontend.a clangSerialization.a clangDriver.a \
           clangRewriteFrontend.a clangToolingCore.a clangRewrite.a \
           clangParse.a clangSema.a clangAnalysis.a \
           clangAST.a clangASTMatchers.a clangEdit.a clangLex.a clangBasic.a

include $(CLANG_LEVEL)/Makefile

=== clang-tidy/tool/CMakeLists.txt ===
set(LLVM_LINK_COMPONENTS
  support
  )

add_clang_executable(clang-tidy
  ClangTidyMain.cpp
  )
target_link_libraries(clang-tidy
  clangAST
  clangASTMatchers
  clangBasic
  clangTidy
  clangTidyGoogleModule
  clangTidyLLVMModule
  clangTidyMiscModule
  clangTidyReadabilityModule
  clangTooling
  )

install(TARGETS clang-tidy
  RUNTIME DESTINATION bin)

=== debian/changelog ===
llvm-toolchain-3.7 (1:3.7~+rc4-1ubuntu1) wily; urgency=medium

  * Merge with Debian; remaining changes:
    - Disable lldb on powerpc, currently ftbfs.
  * libllvm3.7: Add Conflicts/Replaces to libllvm3.7v4 (anticipated backport).
  * Fix build targeting i686.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 28 Aug 2015 13:20:53 +0200

llvm-toolchain-3.7 (1:3.7~+rc4-1) unstable; urgency=medium

  * New snapshot release

  [ Gianfranco Costamagna ]
  * d/control: Add more conflicting packages (python-clang and python-lldb)
    (Closes: #796811, #796843)

 -- Sylvestre Ledru <sylvestre@debian.org>  Thu, 27 Aug 2015 08:53:59 +0200

llvm-toolchain-3.7 (1:3.7~+rc3-1) unstable; urgency=medium

  * New upstream snapshot
  * Remove an obsolete declaration about dragonegg
    (Closes: #796182)

  [ Luciano Bello ]
  * d/p/CVE-2015-2305.patch, fix security issue on regcomp.c

  [ Gianfranco Costamagna ]
  * Fix VCS fields.
  * Fix many lintian warning/errors
    - copyright fixes
    - updated overrides for v5 switch
    - d/control fixes on VCS fields and multiarch.
    - disabled ocaml documentation
  * d/p/bug783205.patch: rebase to 3.7.

  [ James Price ]
  * d/p/fix-cmake-config-prefix.diff: fix cmake path,
    needs a change after upstream revision r241080
    (Closes: #794905)

 -- Sylvestre Ledru <sylvestre@debian.org>  Fri, 21 Aug 2015 12:23:18 +0200

llvm-toolchain-3.7 (1:3.7~+rc2-2ubuntu1) wily; urgency=medium

  * Disable lldb on powerpc, currently ftbfs.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 08 Aug 2015 09:50:34 +0200

llvm-toolchain-3.7 (1:3.7~+rc2-2) unstable; urgency=medium

  * Workaround:
    The 5| in the debian/rules regexp is a crappy workaround. 
    g++ 5.2 in Debian is not providing a g++-5.2 binary (only
    g++-5) accommodate that by hardcoding the 5 detection
    (Closes: #794572)
  * Remove Dummy.html from clang-3.7-doc to avoid install (Closes: #794539)

 -- Sylvestre Ledru <sylvestre@debian.org>  Tue, 04 Aug 2015 09:27:22 +0200

=== debian/control ===
Source: llvm-toolchain-3.7
Section: devel
Priority: optional
Maintainer: LLVM Packaging Team <pkg-llvm-team@lists.alioth.debian.org>
Uploaders: Sylvestre Ledru <sylvestre@debian.org>
Build-Depends: debhelper (>= 9.0), flex, bison, dejagnu, tcl, expect,
    autoconf, automake, perl, libtool, chrpath, texinfo,
    sharutils, autotools-dev (>= 20060702.1), libffi-dev (>= 3.0.9),
    lsb-release, patchutils, diffstat, xz-utils, python-dev,
    libedit-dev, swig, python-sphinx, ocaml-nox, binutils-dev,
    libjsoncpp-dev,
    lcov, procps, help2man, dh-ocaml, zlib1g-dev
Build-Conflicts: oprofile, ocaml, libllvm-3.4-ocaml-dev, libllvm-3.5-ocaml-dev,
 libllvm-3.7-ocaml-dev
Standards-Version: 3.9.6
Homepage: http://www.llvm.org/
Vcs-Svn: svn://anonscm.debian.org/pkg-llvm/llvm-toolchain/branches/3.7/
Vcs-Browser: http://svn.debian.org/viewsvn/pkg-llvm/llvm-toolchain/branches/3.7/

# ------------- clang -------------

Package: clang-3.7
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ${dep:devlibs},
 libclang-common-3.7-dev (= ${binary:Version}),
 libclang1-3.7 (= ${binary:Version}), libc6-dev, binutils
Provides: c-compiler, objc-compiler, c++-compiler
Recommends: llvm-3.7-dev, python
Suggests: gnustep, gnustep-devel, clang-3.7-doc
Replaces: clang-3.1, clang-3.2, clang-3.3,
 clang-3.4 (<< 1:3.4.2-7~exp1), clang-3.5 (<< 1:3.5~+rc1-3~exp1), compiler-rt
Breaks: clang-3.1, clang-3.2, clang-3.3,
 clang-3.4 (<< 1:3.4.2-7~exp1), clang-3.5 (<< 1:3.5~+rc1-3~exp1), compiler-rt
Description: C, C++ and Objective-C compiler (LLVM based)
 Clang project is a C, C++, Objective C and Objective C++ front-end
 for the LLVM compiler. Its goal is to offer a replacement to the GNU Compiler
 Collection (GCC).
 .
 Clang implements all of the ISO C++ 1998 and 2001 standards and also provides
 a partial support of C++1y.

Package: clang-format-3.7
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, python
Replaces: clang-format-3.3
Breaks: clang-format-3.3
Description: Tool to format C/C++/Obj-C code
 Clang-format is both a library and a stand-alone tool with the goal of
 automatically reformatting C++ sources files according to configurable
 style guides. To do so, clang-format uses Clang's Lexer to transform an
 input file into a token stream and then changes all the whitespace around
 those tokens. The goal is for clang-format to both serve both as a user
 tool (ideally with powerful IDE integrations) and part of other
 refactoring tools, e.g. to do a reformatting of all the lines changed
 during a renaming.
 .
 This package also provides vim and emacs plugins.

Package: cpp11-migrate-3.7
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, clang-modernize-3.7
Replaces: cpp11-migrate-3.3
Breaks: cpp11-migrate-3.3
Description: Tool to convert C++98 and C++03 code to C++11
 The purpose of the C++11 Migrator is to do source-to-source translation to
 migrate existing C++ code to use C++11 features to enhance
 maintainability, readability, runtime performance, and compile-time
 performance. Development is still early and transforms fall mostly into
 the first two categories. The migrator is based on Clang's LibTooling and
 the AST Matching library.
 .
 This is a transitional dummy package. It can safely be removed.

Package: clang-modernize-3.7
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, clang-3.7
Replaces: cpp11-migrate-3.3, cpp11-migrate-3.4
Breaks: cpp11-migrate-3.3, cpp11-migrate-3.4
Description: Tool to convert C++98 and C++03 code to C++11
 The purpose of the C++11 Migrator is to do source-to-source translation to
 migrate existing C++ code to use C++11 features to enhance
 maintainability, readability, runtime performance, and compile-time
 performance. Development is still early and transforms fall mostly into
 the first two categories. The migrator is based on Clang's LibTooling and
 the AST Matching library.


Package: clang-3.7-doc
Architecture: all
Section: doc
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: C, C++ and Objective-C compiler (LLVM based) - Documentation
 Clang project is a C, C++, Objective C and Objective C++ front-end
 for the LLVM compiler. Its goal is to offer a replacement to the GNU Compiler
 Collection (GCC).
 .
 Clang implements all of the ISO C++ 1998 and 2001 standards and also provides
 a partial support of C++1y.
 .
 This package contains the documentation.

Package: libclang1-3.7
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ${dep:devlibs}
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Description: C interface to the clang library
 Clang project is a C, C++, Objective C and Objective C++ front-end
 for the LLVM compiler. Its goal is to offer a replacement to the GNU Compiler
 Collection (GCC).
 .
 Clang implements all of the ISO C++ 1998 and 2001 standards and also provides
 a partial support of C++1y.
 .
 This package contains the clang library.
 .
 The C Interface to Clang provides a relatively small API that exposes
 facilities for parsing source code into an abstract syntax tree (AST),
 loading already-parsed ASTs, traversing the AST, associating physical source
 locations with elements within the AST, and other facilities that support
 Clang-based development tools.

Package: libclang1-3.7-dbg
Architecture: any
Multi-Arch: same
Section: debug
Priority: extra
Depends: ${shlibs:Depends}, ${misc:Depends}, ${dep:devlibs}, libclang1-3.7 (= ${binary:Version})
Description: clang library
 Clang project is a C, C++, Objective C and Objective C++ front-end
 for the LLVM compiler. Its goal is to offer a replacement to the GNU Compiler
 Collection (GCC).
 .
 Clang implements all of the ISO C++ 1998 and 2001 standards and also provides
 a partial support of C++1y.
 .
 This package contains the debugging symbols.

Package: libclang-3.7-dev
Architecture: any
Section: libdevel
Depends: ${shlibs:Depends}, ${misc:Depends}, ${dep:devlibs},
 libclang1-3.7 (= ${binary:Version}), libclang-common-3.7-dev (= ${binary:Version})
Description: clang library - Development package
 Clang project is a C, C++, Objective C and Objective C++ front-end
 for the LLVM compiler. Its goal is to offer a replacement to the GNU Compiler
 Collection (GCC).
 .
 Clang implements all of the ISO C++ 1998 and 2001 standards and also provides
 a partial support of C++1y.
 .
 This package contains the clang headers to develop extensions over
 libclang1-3.7.

Package: libclang-common-3.7-dev
Architecture: any
Section: libdevel
Depends: ${shlibs:Depends}, ${misc:Depends}, libllvm3.7 (= ${binary:Version})
Description: clang library - Common development package
 Clang project is a C, C++, Objective C and Objective C++ front-end
 for the LLVM compiler. Its goal is to offer a replacement to the GNU Compiler
 Collection (GCC).
 .
 Clang implements all of the ISO C++ 1998 and 2001 standards and also provides
 a partial support of C++1y.
 .
 This package contains the clang generic headers and some libraries
 (profiling, etc).


Package: python-clang-3.7
Section: python
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, python
Replaces: python-clang-3.3, python-clang-3.4, python-clang-3.5, python-clang-3.6, python-clang-3.8
Breaks: python-clang-3.3, python-clang-3.4, python-clang-3.5, python-clang-3.6, python-clang-3.8
Description: Clang Python Bindings
 Clang project is a C, C++, Objective C and Objective C++ front-end
 for the LLVM compiler. Its goal is to offer a replacement to the GNU Compiler
 Collection (GCC).
 .
 Clang implements all of the ISO C++ 1998 and 2001 standards and also provides
 a partial support of C++1y.
 .
 This binding package provides access to the Clang compiler and libraries.


Package: clang-3.7-examples
Architecture: any
Section: doc
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Clang examples
 Clang project is a C, C++, Objective C and Objective C++ front-end
 for the LLVM compiler. Its goal is to offer a replacement to the GNU Compiler
 Collection (GCC).
 .
 Clang implements all of the ISO C++ 1998 and 2001 standards and also provides
 a partial support of C++1y.
 .
 This package contains the clang examples.

# ------------- LLVM -------------

Package: libllvm3.7
Architecture: any
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Conflicts: libllvm3.7v4
Replaces: libllvm3.7v4
Description: Modular compiler and toolchain technologies, runtime library
 LLVM is a collection of libraries and tools that make it easy to build
 compilers, optimizers, just-in-time code generators, and many other
 compiler-related programs.
 .
 This package contains the LLVM runtime library.

Package: libllvm3.7-dbg
Architecture: any
Section: debug
Priority: extra
Depends: ${shlibs:Depends}, ${misc:Depends}, libllvm3.7 (= ${binary:Version})
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Description: Modular compiler and toolchain technologies, debugging libraries
 LLVM is a collection of libraries and tools that make it easy to build
 compilers, optimizers, just-in-time code generators, and many other
 compiler-related programs.
 .
 This package contains the LLVM runtime library debug symbols.

Package: llvm-3.7
Architecture: any
Suggests: llvm-3.7-doc
Depends: llvm-3.7-runtime (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Recommends: llvm-3.7-dev
Description: Modular compiler and toolchain technologies
 LLVM is a collection of libraries and tools that make it easy to build
 compilers, optimizers, just-in-time code generators, and many other
 compiler-related programs.
 .
 LLVM uses a single, language-independent virtual instruction set both
 as an offline code representation (to communicate code between
 compiler phases and to run-time systems) and as the compiler internal
 representation (to analyze and transform programs). This persistent
 code representation allows a common set of sophisticated compiler
 techniques to be applied at compile-time, link-time, install-time,
 run-time, or "idle-time" (between program runs).
 .
 The strengths of the LLVM infrastructure are its extremely
 simple design (which makes it easy to understand and use),
 source-language independence, powerful mid-level optimizer, automated
 compiler debugging support, extensibility, and its stability and
 reliability. LLVM is currently being used to host a wide variety of
 academic research projects and commercial projects. LLVM includes C
 and C++ front-ends, a front-end for a Forth-like language (Stacker),
 a young scheme front-end, and Java support is in development. LLVM can
 generate code for X86, SparcV9, PowerPC or many other architectures.

Package: llvm-3.7-runtime
Architecture: any
Depends: binfmt-support, ${shlibs:Depends}, ${misc:Depends}
Conflicts: llvm (<< 2.7-1)
Replaces: llvm (<< 2.7-1)
Description: Modular compiler and toolchain technologies, IR interpreter
 LLVM is a collection of libraries and tools that make it easy to build
 compilers, optimizers, just-in-time code generators, and many other
 compiler-related programs.
 .
 LLVM uses a single, language-independent virtual instruction set both
 as an offline code representation (to communicate code between
 compiler phases and to run-time systems) and as the compiler internal
 representation (to analyze and transform programs). This persistent
 code representation allows a common set of sophisticated compiler
 techniques to be applied at compile-time, link-time, install-time,
 run-time, or "idle-time" (between program runs).
 .
 This package provides the minimal required to execute programs in LLVM
 format.

Package: llvm-3.7-dev
Architecture: any
Depends: ${shlibs:Depends}, libffi-dev (>= 3.0.9), ${misc:Depends},
 llvm-3.7 (= ${binary:Version}), libtinfo-dev
Replaces: llvm (<< 2.2-3)
Description: Modular compiler and toolchain technologies, libraries and headers
 LLVM is a collection of libraries and tools that make it easy to build

=== debian/rules ===
#!/usr/bin/make -f

TARGET_BUILD	:= build-llvm
DEB_INST		:= $(CURDIR)/debian/tmp/
#GCC_VERSION     := 4.8
# The 5| in the regexp is a crappy workaround. g++ 5.2 in Debian is not providing a g++-5.2 binary (only g++-5)
# accomodate that by hardcoding the 5 detection
GCC_VERSION     := $(shell dpkg-query -W -f '$${Version}' g++ | sed -rne 's,^([0-9]+:)?(5|[0-9]+\.[0-9]+|[0-9]+).*$$,\2,p')
LLVM_VERSION	:= 3.7
LLVM_VERSION_FULL := $(LLVM_VERSION).0
SONAME_EXT      := 1
# Manage the case when the version is 1:3.5~svn213052-1~exp1 or 1:3.4.2-1
DEBIAN_REVISION := $(shell dpkg-parsechangelog |  sed -rne "s,^Version: 1:([0-9.]+)(~|-)(.*),\3,p")
ifneq (,$(filter parallel=%,$(subst $(COMMA), ,$(DEB_BUILD_OPTIONS))))
  NJOBS := -j $(subst parallel=,,$(filter parallel=%,$(subst $(COMMA), ,$(DEB_BUILD_OPTIONS))))
endif

VENDOR=$(shell lsb_release -is)

AUTOCONF_BUILD=yes
BUILD_DIR=Release

DEB_HOST_MULTIARCH  = $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
DEB_HOST_GNU_TYPE   = $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_HOST_ARCH_BITS  = $(shell dpkg-architecture -qDEB_HOST_ARCH_BITS)
DEB_HOST_ARCH       = $(shell dpkg-architecture -qDEB_HOST_ARCH)

OCAML_STDLIB_DIR    ?= $(shell ocamlc -where)

LDFLAGS_EXTRA =
CXXFLAGS_EXTRA = -std=c++0x
CONFIGURE_EXTRA =

ifneq (,$(filter $(DEB_HOST_ARCH),powerpc powerpcspe))
LDFLAGS_EXTRA += -latomic
endif

ifeq ($(shell dpkg --compare-versions $(shell dpkg-query -W -f '$${Version}' g++-$(GCC_VERSION)) lt 4.7.2-10~ ; echo $$?),0)
# Too old version of gcc. Force 4.9
	GCC_VERSION := 4.9
endif

export CC=gcc-$(GCC_VERSION)
export CXX=g++-$(GCC_VERSION)

confargs := \
	--host=$(DEB_HOST_GNU_TYPE) --build=$(DEB_BUILD_GNU_TYPE)

ifeq ($(shell dpkg-architecture -qDEB_HOST_ARCH_BITS),64)
  confargs += --with-cxx-include-32bit-dir=32
else
  confargs += --with-cxx-include-64bit-dir=64
endif

opt_flags = -g -O2
ifneq (,$(findstring $(DEB_HOST_ARCH),armel))
  opt_flags += -marm
endif

ifeq ($(shell dpkg --compare-versions $(shell dpkg-query -W -f '$${Version}' g++-$(GCC_VERSION)) ge 4.8-20121128-1~ ; echo $$?),0)
	control_vars = '-Vdep:devlibs=libstdc++-$(GCC_VERSION)-dev, libgcc-$(GCC_VERSION)-dev, libobjc-$(GCC_VERSION)-dev'
else ifeq ($(shell dpkg --compare-versions $(shell dpkg-query -W -f '$${Version}' g++-$(GCC_VERSION)) ge 4.7.2-10~ ; echo $$?),0)
	control_vars = '-Vdep:devlibs=libstdc++6-$(GCC_VERSION)-dev, libgcc-$(GCC_VERSION)-dev, libobjc-$(GCC_VERSION)-dev'
else
	control_vars = '-Vdep:devlibs=libstdc++6-$(GCC_VERSION)-dev'
endif

BINUTILS_GOLD_ARCHS := amd64 armhf i386 powerpc powerpcspe ppc64 ppc64el sparc sparc64 x32
ifeq ($(shell dpkg --compare-versions $(shell dpkg-query -W -f '$${Version}' binutils) ge 2.23.1-1~exp3 ; echo $$?),0)
ifneq (,$(findstring $(DEB_HOST_ARCH),$(BINUTILS_GOLD_ARCHS)))
# -fused-ld=gold enables the gold linker (but is not supported by all archs / distro)
	LDFLAGS_EXTRA += -fuse-ld=gold
endif
endif

# Enable polly (or not)
POLLY_ENABLE=yes

ifneq (,$(filter codecoverage,$(DEB_BUILD_OPTIONS)))
# enable the code coverage
	CODECOVERAGE=yes
# for -fvisibility-inlines-hidden see http://lists.cs.uiuc.edu/pipermail/llvm-commits/Week-of-Mon-20130729/183016.html
	CXXFLAGS_EXTRA += -fprofile-arcs -ftest-coverage
	LDFLAGS_EXTRA += -coverage -lgcov
	confargs += llvm_cv_cxx_visibility_inlines_hidden=no
endif

ifneq (,$(filter scan-build,$(DEB_BUILD_OPTIONS)))
# enable the build using scan-build
# The package are installed through the variable declarations:
# OTHERMIRROR="deb http://llvm.org/apt/unstable/ llvm-toolchain main"
# EXTRAPACKAGES="clang-3.5"
	PRE_PROCESS=scan-build-$(LLVM_VERSION) -analyzer-config stable-report-filename=true
	PRE_PROCESS_CONF=scan-build-$(LLVM_VERSION)
# no need to run tests in this case
	DEB_BUILD_OPTIONS+=" nocheck"
	CONFIGURE_EXTRA += --enable-assertions
endif

ifneq (,$(filter coverity,$(DEB_BUILD_OPTIONS)))
# enable the build using coverity
# pbuilder contains BINDMOUNTS="/opt/cov-analysis/"
# And we have some pbuilder hooks to configure and pack the result
# Where the binaries are installed on the jenkins instance
	PRE_PROCESS=PATH=$$PATH:/opt/cov-analysis/bin/ cov-build --dir cov-int
# We don't want to check the temporary files produced by the configure
	PRE_PROCESS_CONF=
	COVERITY_ENABLE=1
	CONFIGURE_EXTRA += --enable-assertions
# no need to run tests in this case
	DEB_BUILD_OPTIONS+=" nocheck"
else
	COVERITY_ENABLE=0
endif


LLDB_ENABLE=yes
LLDB_DISABLE_ARCHS := arm64 hurd-i386 ia64 ppc64el powerpc
# hurd has threading issues
ifeq (,$(filter-out $(LLDB_DISABLE_ARCHS), $(DEB_HOST_ARCH)))
# Disable LLDB for this arch.
		LLDB_ENABLE=no
endif


%:
	dh $@ --with ocaml



preconfigure:
	for f in debian/*.in; do \
		f2=$$(echo $$f | sed 's/\.in$$//;s/X\.Y/$(LLVM_VERSION)/'); \
		echo "$$f => $$f2"; \
		sed -e 's|@DEB_HOST_MULTIARCH@|$(DEB_HOST_MULTIARCH)|g' \
			-e "s|@OCAML_STDLIB_DIR@|$(OCAML_STDLIB_DIR)|g" \
			-e "s|@LLVM_VERSION_FULL@|$(LLVM_VERSION_FULL)|g" \
			-e "s|@LLVM_VERSION@|$(LLVM_VERSION)|g" $$f > $$f2; \
	done

# Override this two targets. They are trying to manage the .in conversion for me
override_dh_ocamlinit:
override_dh_ocamlclean:

override_dh_auto_configure: preconfigure
	echo "Using gcc: "
	$(CC) -v
	mkdir -p $(TARGET_BUILD)
	mkdir -p clang/include/clang/Debian
	sed -e "s|@DEB_PATCHSETVERSION@|$(DEBIAN_REVISION)|" \
		debian/debian_path.h > clang/include/clang/Debian/debian_path.h

# Remove some old symlinks
	cd tools/ && \
		if test -h clang; then \
			rm clang; \
		fi; \
		ln -s ../clang .; \
	readlink clang

	if test $(POLLY_ENABLE) = yes; then \
		cd tools/ && \
		if test -h polly; then \
			rm polly; \
		fi; \
		ln -s ../polly .; \
	fi

	if test $(LLDB_ENABLE) = yes; then \
		cd tools/ && \
		if test -h lldb; then \
		   rm lldb; \
		fi; \
		ln -s ../lldb .; \
	fi

	cd projects/ && \
	if test -h compiler-rt; then \
		rm compiler-rt; \
	fi; \
	ln -s ../compiler-rt .; \
	readlink compiler-rt

	# Configure coverity (we need the compilers)
	-(if test $(COVERITY_ENABLE) -eq 1; then \
		export PATH=$$PATH:/opt/cov-analysis/bin/; \
		cov-configure --compiler clang --comptype clang; \
		cov-configure --compiler gcc-4.8 --comptype gcc; \
		cov-configure --compiler g++-4.8 --comptype gcc; \
		cov-configure --compiler gcc-4.9 --comptype gcc; \
		cov-configure --compiler g++-4.9 --comptype gcc; \
	fi)

	# Due to bug upstream, no symlink here
	cp -R -H clang-tools-extra tools/clang/tools/extra

	if test $(AUTOCONF_BUILD) = yes; then \
		cd $(TARGET_BUILD); \
		$(PRE_PROCESS_CONF) \
		../configure $(confargs) \
		--prefix=/usr/lib/llvm-$(LLVM_VERSION) \
		--bindir=\$${prefix}/bin/ \
		--disable-assertions \
		--enable-shared \
		--enable-optimized \
		--with-optimize-option=' $(opt_flags)' \
		--enable-pic \
		--enable-libffi \
		--libdir=\$${prefix}/lib/$(DEB_HOST_MULTIARCH) \
		--with-binutils-include=/usr/include \
		--with-cloog --with-isl \
		--with-bug-report-url=http://bugs.debian.org/ \
		--enable-shared \
	        --disable-bindings \
		$(CONFIGURE_EXTRA) \
		CLANG_VENDOR=$(VENDOR) || { cat config.log tools/polly/config.log; exit 1; }; \
	else \
		cd $(TARGET_BUILD) && \
		cmake ../ \
		-DCMAKE_INSTALL_PREFIX=/usr/lib/llvm-$(LLVM_VERSION) \
		-DCMAKE_VERBOSE_MAKEFILE=ON -DBUILD_SHARED_LIBS=on; \
	fi
#	cd $(TARGET_BUILD) && cmake ../ -DCMAKE_INSTALL_PREFIX=/usr -DCMAKE_VERBOSE_MAKEFILE=ON
#	mkdir build-compiler-rt && cd build-compiler-rt && cmake ../compiler-rt
#        --with-ocaml-libdir=/usr/lib/ocaml/llvm-$(LLVM_VERSION) \


override_dh_auto_build:
	$(PRE_PROCESS) $(MAKE) $(NJOBS) -C $(TARGET_BUILD) VERBOSE=1 CLANG_VENDOR=$(VENDOR) CXXFLAGS="$(CXXFLAGS_EXTRA)"  LDFLAGS="$(LDFLAGS_EXTRA)" REQUIRES_RTTI=1 DEBUGMAKE=1

# We run the build with the Asserts, new directory, make a symlink to make
# sure the rest still work
	cd $(TARGET_BUILD) \
	if test -d Release+Asserts -a ! -e Release; then \
		ln -s Release+Asserts Release; \
	fi


override_dh_prep: build_doc
	dh_prep


build_doc:
